<?php

include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/model/db.php');

// Get all the optin data

$nnrobots_content_fire_db = new NNRobots_Content_Fire_DB();
$ctas = $nnrobots_content_fire_db->get_content_fires();

$valid_cta = array();

foreach ( $ctas as $cta ) {

	if (isset($cta['template']) && !is_array($cta['template'])) $cta['template'] = (array) NNRobots_Content_Fire_Admin_Functions::mb_unserialize($cta['template']);
	if (isset($cta['style']) && !is_array($cta['style'])) $cta['style'] = (array) unserialize($cta['style']);
	if (isset($cta['trigger']) && !is_array($cta['trigger'])) $cta['trigger'] = (array) unserialize($cta['trigger']);
	if (isset($cta['social']) && !is_array($cta['social'])) $cta['social'] = (array) unserialize($cta['social']);
	if (isset($cta['news_letter']) && !is_array($cta['news_letter'])) $cta['news_letter'] = (array) unserialize($cta['news_letter']);
	if (isset($cta['args']) && !is_array($cta['args'])) $cta['args'] = (array) NNRobots_Content_Fire_Admin_Functions::mb_unserialize($cta['args']);

	$valid_cta[] = $cta;

}

$export_data = array(
	'from-plugin'	=> 'content-fire',
	'data'			=> $valid_cta,
);

// Import the Data

if ( isset($_POST['submit']) && check_admin_referer(self::$prefix . 'import_export') ) {

	$import_data = json_decode(stripcslashes($_POST[self::$prefix_dash . 'import-data']), true);

	if ( isset($import_data) ) {

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/functions.php');

		$check = true;

		foreach ( $import_data['data'] as $data ) {

			if ( $import_data['from-plugin'] == 'content-fire' ) {

				// Assign Default Values to all non-matching values

				$data = array_merge( NNRobots_Content_Fire_Admin_Functions::default_content_fire(), $data );

				$content_fire_id = $nnrobots_content_fire_db->add_data($data);

			} else {
				$check = false;
				break;
			}
		}

		// Show a message

		if ( $check ) {
			?>
			<script type="text/javascript">
				window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$import_export_page; ?>&status=success&import_message=<?php echo urlencode(__(count($import_data['data']) . ' CTAs have been imported successfully.', self::$text_domain)); ?>";
			</script>
			<?php
		}

	}

}

// Show the good stuff

require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/views/import-export.php');