<?php

/*
 * This file is used for controlling the data for the stats page
 */

include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

// Create Table if one does not exist

global $wpdb;

NNRobots_Stats_CF::createTable();

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing') {

	$nnrobots_content_fire_db = new NNRobots_Content_Fire_DB();
	$content_fire = $nnrobots_content_fire_db->get_data_from_id($_GET['content_fire_id']);
	$content_fire['args'] = unserialize($content_fire['args']);

}

// Get global settings

$global_settings = get_option(self::$prefix . 'global_settings');

if ( $global_settings === false ) {
	$global_settings = NNRobots_Content_Fire_Admin_Functions::default_global_settings();
}

// Save A/B Testing settings

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing' && isset($_GET['action1']) && check_admin_referer(self::$prefix . 'ab_testing')) {

	$content_fire = $nnrobots_content_fire_db->get_data_from_id($_GET['content_fire_id']);

	$content_fire['social']         = unserialize($content_fire['social']);
	$content_fire['news_letter']    = unserialize($content_fire['news_letter']);
	$content_fire['template']       = unserialize($content_fire['template']);
	$content_fire['trigger']        = unserialize($content_fire['trigger']);
	$content_fire['style']          = unserialize($content_fire['style']);
	$content_fire['args']           = unserialize($content_fire['args']);

	if ($_GET['action1'] == 'start') {

		$content_fire['args']['ab_testing']['active'] = true;
		$content_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT);

		// Create new content_fire with same settings as current one.

		$ab_content_fire = $content_fire;
		$ab_content_fire['name'] .= ' A/B Testing';
		$ab_content_fire['args']['ab_testing']['active'] = true;
		$ab_content_fire['args']['ab_testing']['content_fire_id'] = $content_fire['id'];
		$ab_content_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT);
		$nnrobots_content_fire_db->add_data($ab_content_fire);

		$content_fire['args']['ab_testing']['content_fire_id'] = $wpdb->insert_id;

	} else if ($_GET['action1'] == 'stop') {
		$content_fire['args']['ab_testing']['active'] = false;
		$ab_content_fire = $nnrobots_content_fire_db->get_data_from_id($content_fire['args']['ab_testing']['content_fire_id']);
		$content_fire['args']['ab_testing']['content_fire_id'] = '0';
		$content_fire['args']['ab_testing']['start_date'] = '';

		if (isset($ab_content_fire)) {

			$ab_content_fire['social']         = unserialize($ab_content_fire['social']);
			$ab_content_fire['news_letter']    = unserialize($ab_content_fire['news_letter']);
			$ab_content_fire['template']       = unserialize($ab_content_fire['template']);
			$ab_content_fire['trigger']        = unserialize($ab_content_fire['trigger']);
			$ab_content_fire['style']          = unserialize($ab_content_fire['style']);
			$ab_content_fire['args']           = unserialize($ab_content_fire['args']);

			$ab_content_fire['args']['ab_testing']['active'] = false;
			$ab_content_fire['args']['ab_testing']['content_fire_id'] = '0';
			$ab_content_fire['args']['ab_testing']['start_date'] = '';
			$nnrobots_content_fire_db->update_data($ab_content_fire);
		}

	}

	$nnrobots_content_fire_db->update_data($content_fire);
	?>
	<script type="text/javascript">
		window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
	</script>
	<?php
}

// Export data

if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'export_data')) {

	$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
	$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

	if (isset($_GET[self::$prefix_dash . 'start-date']) && $_GET[self::$prefix_dash . 'start-date'] != '') {
		$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'start-date']));
	}

	if (isset($_GET[self::$prefix_dash . 'end-date']) && $_GET[self::$prefix_dash . 'end-date'] != '') {
		$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'end-date']));
	}

	global $wpdb;
	$content_fire_stats = NNRobots_Stats_CF::getStats($start_date, $end_date, $_GET['content_fire_id']);
	$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");

	foreach ($content_fires as $content_fire) {
		foreach ($content_fire_stats as $key => $content_fire_stat) {
			if ($content_fire->id == $content_fire_stat['content_fire_id']) {
				$content_fire_stats[$key] = array('content_fire_name' => $content_fire->name) + $content_fire_stats[$key];

				$ctr = $content_fire_stats[$key]['impressions'] != 0 ? round(($content_fire_stats[$key]['clicks']/$content_fire_stats[$key]['impressions']) * 100,2) : 0;

				$content_fire_stats[$key]['click-through-rate'] = $ctr . '%';

			}
		}
	}

	// Unset indexes

	foreach ($content_fire_stats as $key => $content_fire_stat) {
		unset($content_fire_stats[$key]['id']);
		unset($content_fire_stats[$key]['content_fire_id']);
	}

	$filename =  self::$prefix . 'stats.csv';
	$export_file = fopen(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'exports/' . $filename, "w");
	fputcsv($export_file, array('Name', 'Date', 'Impressions', 'Conversions', 'Conversion Rate'));

	foreach (array_reverse($content_fire_stats) as $content_fire_stat) {
	    fputcsv($export_file, $content_fire_stat);
	}

	fclose($export_file);

	?>
	<script type="text/javascript">
		window.location = '<?php echo NNROBOTS_CONTENT_FIRE_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
	</script>
	<?php
}

$ab_start_date = date('m/d/Y');

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing') {

	$nnrobots_content_fire_db = new NNRobots_Content_Fire_DB();

	$content_fire = $nnrobots_content_fire_db->get_data_from_id($_GET['content_fire_id']);
	$content_fire['args'] = unserialize($content_fire['args']);

	$ab_start_date = date('m/d/Y', strtotime($content_fire['args']['ab_testing']['start_date']));
}

wp_enqueue_script(self::$prefix . 'stats_js', NNROBOTS_CONTENT_FIRE_PLUGIN_URL . '/admin/js/stats.js', array('jquery'));
wp_localize_script(self::$prefix . 'stats_js', 'nnr_cf_stats_data', array(
	'prefix_dash' 		=> self::$prefix_dash,
	'today'				=> date('m/d/Y'),
	'ab_start_date'		=> $ab_start_date,
	'date_format'		=> NNROBOTS_CONTENT_FIRE_DATE_FORMAT,
));

require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/views/stats.php');