<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('NNRobots_Content_Fire_Admin_Functions') ) :

// AJAX calls to load stats and emails

add_action( 'wp_ajax_nnr_cf_stats_load', 					array('NNRobots_Content_Fire_Admin_Functions', 'stats_load'));
add_action( 'wp_ajax_nnr_cf_emails_load', 					array('NNRobots_Content_Fire_Admin_Functions', 'emails_load'));
add_action( 'wp_ajax_nnr_cf_entries_load', 					array('NNRobots_Content_Fire_Admin_Functions', 'entries_load'));
add_action( 'wp_ajax_nnr_cf_entry_load', 					array('NNRobots_Content_Fire_Admin_Functions', 'entry_load'));

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_nnr_cf_get_categories', 				array('NNRobots_Content_Fire_Admin_Functions', 'get_categories'));
add_action( 'wp_ajax_nnr_cf_get_tags', 						array('NNRobots_Content_Fire_Admin_Functions', 'get_tags'));
add_action( 'wp_ajax_nnr_cf_get_posts', 					array('NNRobots_Content_Fire_Admin_Functions', 'get_posts'));

// AJAX calls to get Newsletter lists

add_action( 'wp_ajax_nnr_cf_get_mailchimp_lists', 			array('NNRobots_Content_Fire_Admin_Functions', 'get_mailchimp_lists'));
add_action( 'wp_ajax_nnr_cf_get_aweber_lists', 				array('NNRobots_Content_Fire_Admin_Functions', 'get_aweber_lists'));
add_action( 'wp_ajax_nnr_cf_get_getresponse_lists', 		array('NNRobots_Content_Fire_Admin_Functions', 'get_getresponse_lists'));
add_action( 'wp_ajax_nnr_cf_get_campaignmonitor_lists', 	array('NNRobots_Content_Fire_Admin_Functions', 'get_campaignmonitor_lists'));
add_action( 'wp_ajax_nnr_cf_update_campaignmonitor_lists', 	array('NNRobots_Content_Fire_Admin_Functions', 'update_campaignmonitor_lists'));
add_action( 'wp_ajax_nnr_cf_get_madmimi_lists', 			array('NNRobots_Content_Fire_Admin_Functions', 'get_madmimi_lists'));
add_action( 'wp_ajax_nnr_cf_get_infusionsoft_lists', 		array('NNRobots_Content_Fire_Admin_Functions', 'get_infusionsoft_lists'));
add_action( 'wp_ajax_nnr_cf_get_mymail_lists', 				array('NNRobots_Content_Fire_Admin_Functions', 'get_mymail_lists'));
add_action( 'wp_ajax_nnr_cf_get_activecampaign_lists', 		array('NNRobots_Content_Fire_Admin_Functions', 'get_activecampaign_lists'));

// Cron jobs

add_action( 'initialize_content_fire_stats_daily_cron', 	array('NNRobots_Content_Fire_Admin_Functions', 'initialize_content_fire_stats_daily'), 10 ,2 );
add_action( 'setup_content_fire_email_stats_cron', 			array('NNRobots_Content_Fire_Admin_Functions', 'setup_content_fire_email_stats'), 10 ,2 );

// Miscellaneous

add_action( 'wp_ajax_nnr_cf_send_weekly_email', 			array('NNRobots_Content_Fire_Admin_Functions', 'send_weekly_email'));

// Shortcode Media Buttons

add_action( 'media_buttons', 								array('NNRobots_Content_Fire_Admin_Functions', 'add_media_buttons'), 20);
add_action( 'wp_enqueue_media', 							array('NNRobots_Content_Fire_Admin_Functions', 'include_shortcode_button_scripts'));

/**
 *
 * Main class for all admin functions
 *
 * @since 1.1.2
 */
class NNRobots_Content_Fire_Admin_Functions {

	/**
	 * Add a media button for adding Optin Fire shortcode
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function add_media_buttons(){

		// Include DB file for accessing optins

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . '/admin/model/db.php');

		$content_fire_db = new NNRobots_Content_Fire_DB();
		$ctas = $content_fire_db->get_content_fires();

		echo '<button class="button ' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-builder"><span></span>Content Fire</button>
		<div class="' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-builder-container">
		<div class="postbox ' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-builder-box" style="display:none;">
			<h3>
				<span>' . __('Optin Fire Shortcode Builder', NNRobots_Content_Fire::$text_domain) . '</span>

				<button style="float: right;margin-right: 0px;" class="button ' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-builder-close">Close</button>
				<button style="float: right;margin-right: 12px;" class="button button-primary ' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-builder-add">Insert Shortcode</button>
			</h3>
			<div class="inside">
				<p style="display:none;">
					<strong><label for="' . NNRobots_Content_Fire::$prefix_dash . 'shortcode">' . __( 'ShortCode:', NNRobots_Content_Fire::$text_domain). '</label></strong>
					<code class="' . NNRobots_Content_Fire::$prefix_dash . 'shortcode"></code>
				</p>

				<!-- Content -->

				<p>
					<strong><label for="' . NNRobots_Content_Fire::$prefix_dash . 'content">' . __( 'CTA:', NNRobots_Content_Fire::$text_domain) . '</label></strong>
					<select id="' . NNRobots_Content_Fire::$prefix_dash . 'id" name="' . NNRobots_Content_Fire::$prefix_dash . 'id" class="' . NNRobots_Content_Fire::$prefix_dash . 'shortcode-input" data-shortcode="id">';

					foreach ( $ctas as $cta ) {
						echo '<option value="' . $cta['id'] . '">' . __( $cta['name'], NNRobots_Content_Fire::$text_domain). '</option>';
					}

					echo '</select><br/>
					<em>' . __('Select the CTA you want to display.', NNRobots_Content_Fire::$text_domain). '</em>
				</p>

			</div>
		</div>
		</div>';

	}

	/**
	 * Include the shortcode builder stylesheet and script
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function include_shortcode_button_scripts() {

		if ( isset($_GET['post']) ) {

			// Styles

			wp_enqueue_style(NNRobots_Content_Fire::$prefix . 'shortcode_builder_css', NNROBOTS_CONTENT_FIRE_PLUGIN_URL . '/admin/css/shortcode-builder.css');

			// Scripts

			wp_enqueue_script(NNRobots_Content_Fire::$prefix . 'shortcode_builder_js', NNROBOTS_CONTENT_FIRE_PLUGIN_URL . '/admin/js/shortcode-builder.js', array('jquery'));
			wp_localize_script(NNRobots_Content_Fire::$prefix . 'shortcode_builder_js', 'nnr_cf_shortcode', array(
				'prefix' 	=> NNRobots_Content_Fire::$prefix_dash,
			));
		}

	}

	/**
	 * Return a default content_fire
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_content_fire() {
		return array(
			'id' 			=> '',
			'name' 			=> '',
			'title' 		=> __('Content Fire', NNRobots_Content_Fire::$text_domain),
			'text' 			=> __('Create CTAs that display the right message at the right time', NNRobots_Content_Fire::$text_domain),
			'image' 		=> '',
			'news_letter' 	=> array(
				'type' 						=> 'WordPress',
				'first_name_placeholder'	=> __('First Name', NNRobots_Content_Fire::$text_domain),
				'last_name_placeholder'		=> __('Last Name', NNRobots_Content_Fire::$text_domain),
				'email_placeholder'			=> __('Email', NNRobots_Content_Fire::$text_domain),
				'first_name'				=> true,
				'last_name'					=> true,
				'success_action'			=> 'message',
				'success_url'				=> '',
				'success_message'			=> __('We will be in touch soon!', NNRobots_Content_Fire::$text_domain),
				'button_text'				=> __('Subscribe', NNRobots_Content_Fire::$text_domain),
				'MailChimp' => array(
					'api_key'	=> '',
					'list'		=> '',
					'optin'		=> true,
				),
				'aweber' => array(
					'consumer_key' 		=> '',
					'consumer_secret' 	=> '',
					'access_key' 		=> '',
					'access_secret' 	=> '',
					'account_id' 		=> '',
					'list_id' 			=> ''
				),
				'getresponse'	=> array(
					'api_key' 		=> '',
					'campaign'		=> '',
				),
				'campaignmonitor'	=> array(
					'api_key'			=> '',
					'client' 			=> '',
					'list'				=> '',
				),
				'madmimi'	=> array(
					'api_key'			=> '',
					'username' 			=> '',
					'list'				=> '',
				),
				'infusionsoft'	=> array(
					'app_id'			=> '',
					'api_key' 			=> '',
					'list'				=> '',
				),
				'mymail' 	=> array(
					'list'		=> '',
				),
				'activecampaign' 	=> array(
					'api_url'	=> '',
					'api_key'	=> '',
					'list'		=> '',
				),
				'feedburner' 	=> array(
					'id'		=> ''
				)
			),
			'template' 		=> array(
				'type'		=> '3',
				'args'		=> array(
					'call_to_action'		=> 'newsletter',
					'footer'				=> __('We promise never to spam or share your information.', NNRobots_Content_Fire::$text_domain),
					'footer_icon'			=> 'fa-lock',
					'subscribe_icon'		=> 'fa-envelope',
					'subscribe_icon_place'	=> 'before',
					'contact_icon'			=> 'fa-envelope',
					'contact_icon_place'	=> 'before',
					'link_type' 			=> 'button',
					'link_target' 			=> '_blank',
					'link_rel' 				=> true,
					'link_url' 				=> 'http://wpsite.net',
					'link_name' 			=> 'Click Here!',
					'link_text_color'		=> '#ffffff',
					'link_button_color'		=> '#4FC000',
					'yes_text' 				=> __('YES', NNRobots_Content_Fire::$text_domain),
					'yes_sub_text' 			=> __("let's do this.", NNRobots_Content_Fire::$text_domain),
					'yes_link_target' 		=> '_blank',
					'yes_link_rel' 			=> true,
					'yes_link_url' 			=> 'http://wpsite.net',
					'no_text' 				=> __('NO', NNRobots_Content_Fire::$text_domain),
					'no_sub_text' 			=> __("let's consider it gone.", NNRobots_Content_Fire::$text_domain),
					'no_link_target' 		=> '_blank',
					'no_link_rel' 			=> true,
					'no_link_url' 			=> 'http://wpsite.net',
					'list'					=>  array(
						'color'			=> '#000000',
						'items'			=> array(
							array('icon' => 'fa-envelope', 'text' => __('Increase signups', NNRobots_Content_Fire::$text_domain)),
							array('icon' => 'fa-line-chart', 'text' => __('Drive more traffic', NNRobots_Content_Fire::$text_domain)),
							array('icon' => 'fa-crosshairs', 'text' => __('Create targeted call to action', NNRobots_Content_Fire::$text_domain)),
							array('icon' => 'fa-comment-o', 'text' => __('Display the right message at the right time', NNRobots_Content_Fire::$text_domain)),
							array('icon' => 'fa-group', 'text' => __('Show your content to the correct audience', NNRobots_Content_Fire::$text_domain)),
						),
					),
					'contact_us'  => array(
						'email_placeholder'			=> __('Email', NNRobots_Content_Fire::$text_domain),
						'subject_placeholder'		=> __('Subject', NNRobots_Content_Fire::$text_domain),
						'message_placeholder'		=> __('Message', NNRobots_Content_Fire::$text_domain),
						'button_text'				=> __('Contact Us', NNRobots_Content_Fire::$text_domain),
						'email'						=> get_bloginfo('admin_email'),
					),
				),
			),
			'trigger' 		=> array(
				'display_on'	=> 'post',
				'args'			=> array(
					'users'			=> 'any',
					'user_roles'	=> array(),
					'referrer_type'	=> 'any',
					'referrer'		=> 't.co,www.facebook.com,plus.url.google.com,www.linkedin.com',
				),
			),
			'style'			=> array(
				'background_type'		=> 'pattern',
				'background_image'		=> '',
				'background_color' 		=> '#ffffff',
				'background_pattern'	=> 'none',
				'background_size'		=> 'auto',
				'background_repeat'		=> 'no-repeat',
				'background_position'	=> 'center center',
				'color' 				=> '#333333',
				'heading_color' 		=> '#333333',
				'border_color' 			=> '#4FC000',
				'accent_color'			=> '#5bc0de',
				'button_shape'			=> 'rounded',
				'nl_color' 				=> '#ffffff',
				'nl_bg_color' 			=> '#4FC000',
				'cu_color' 				=> '#ffffff',
				'cu_bg_color' 			=> '#4FC000',
				'yes_color' 			=> '#ffffff',
				'yes_bg_color' 			=> '#4FC000',
				'no_color' 				=> '#ffffff',
				'no_bg_color' 			=> '#d9534f',
				'font_size'				=> 'auto',
				'font_weight'			=> 'normal',
				'google_fonts'			=> false,
				'heading_google_fonts'	=> false,
				'font_family_heading'	=> 'Arial, Helvetica, sans-serif',
				'font_family'			=> 'Arial, Helvetica, sans-serif',
				'custom_css'			=> '',
			),
			'active' 		=> 'Active',
			'args'			=> array(
				'start_date'			=> null,
				'end_date'				=> null,
				'mobile'				=> 'yes',
				'dismiss'				=> '1440',
				'show_after_success'	=> 'no',
				'powered_by'			=> 'yes',
				'ab_testing'			=> array(
					'active'			=> false,
					'content_fire_id'		=> '',
				),
				'placement'				=> array(
					'type'				=> 'after',
					'paragraphs'		=> '1',
					'headlines'			=> '1',
				)
			)
		);
	}

	/**
	 * Default settings for all content fires
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_global_settings() {
		return array(
			'send_weekly_email'	=> true,
		);
	}

	/**
	 * Get all the data into an array format to save to the DB
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function save_data() {

		global $wp_roles;

		$post_types = get_post_types(array('public' => true));

		$default_content_fire = self::default_content_fire();

		$val['name']                                      = stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'name']));

		$val['title']                                     = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'title']) ?
															stripslashes($_POST[NNRobots_Content_Fire::$prefix_dash . 'title']) :
															$default_content_fire['title'];

		$val['text']                                      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'text']) ?
															stripslashes($_POST[NNRobots_Content_Fire::$prefix_dash . 'text']) :
															$default_content_fire['text'];

		$val['image']                                     = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'image']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'image']) :
															$default_content_fire['image'];

		$val['active']                                    = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'active']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'active'] :
															$default_content_fire['active'];

		// Template

		$val['template']['type']                          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-type']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-type'] :
															$default_content_fire['template']['type'];

		$val['template']['args']['call_to_action']        = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-call-to-action']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-call-to-action'] :
															$default_content_fire['template']['args']['call_to_action'];

		$val['template']['args']['footer']                = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-footer']) ?
															stripcslashes($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-footer']) :
															$default_content_fire['template']['args']['footer'];

		$val['template']['args']['footer_icon']           = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-footer-icon']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-footer-icon'] :
															$default_content_fire['template']['args']['footer_icon'];

		$val['template']['args']['subscribe_icon']        = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-subscribe-icon']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-subscribe-icon'] :
															$default_content_fire['template']['args']['subscribe_icon'];

		$val['template']['args']['subscribe_icon_place']  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-subscribe-icon-place']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-subscribe-icon-place'] :
															$default_content_fire['template']['args']['subscribe_icon_place'];

		$val['template']['args']['contact_icon']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-contact-icon']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-contact-icon'] :
															$default_content_fire['template']['args']['contact_icon'];

		$val['template']['args']['contact_icon_place']    = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-contact-icon-place']) ?
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-contact-icon-place'] :
															$default_content_fire['template']['args']['contact_icon_place'];

		$val['template']['args']['link_type']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-type']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-type']) :
															$default_content_fire['template']['args']['link_type'];

		$val['template']['args']['link_target']           = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-target']) :
															$default_content_fire['template']['args']['link_target'];

		$val['template']['args']['link_rel']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-rel']) :
															$default_content_fire['template']['args']['link_rel'];

		$val['template']['args']['link_url']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-url']) :
															$default_content_fire['template']['args']['link_url'];

		$val['template']['args']['link_name']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-name']) ?
															stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-name'])) :
															$default_content_fire['template']['args']['link_name'];

		$val['template']['args']['link_text_color']       = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-text-color']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-text-color']) :
															$default_content_fire['template']['args']['link_text_color'];

		$val['template']['args']['link_button_color']     = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-button-color']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-link-button-color']) :
															$default_content_fire['template']['args']['link_button_color'];

		$val['template']['args']['yes_text']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-text']) ?
															stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-text'])) :
															$default_content_fire['template']['args']['yes_text'];

		$val['template']['args']['yes_sub_text']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-sub-text']) ?
															stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-sub-text'])) :
															$default_content_fire['template']['args']['yes_sub_text'];

		$val['template']['args']['yes_link_target']       = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-target']) :
															$default_content_fire['template']['args']['yes_link_target'];

		$val['template']['args']['yes_link_rel']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-rel']) :
															$default_content_fire['template']['args']['yes_link_rel'];

		$val['template']['args']['yes_link_url']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-yes-link-url']) :
															$default_content_fire['template']['args']['yes_link_url'];

		$val['template']['args']['no_text']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-text']) ?
															stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-text'])) :
															$default_content_fire['template']['args']['no_text'];

		$val['template']['args']['no_sub_text']           = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-sub-text']) ?
															stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-sub-text'])) :
															$default_content_fire['template']['args']['no_sub_text'];

		$val['template']['args']['no_link_target']        = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-target']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-target']) :
															$default_content_fire['template']['args']['no_link_target'];

		$val['template']['args']['no_link_rel']           = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-rel']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-rel']) :
															$default_content_fire['template']['args']['no_link_rel'];

		$val['template']['args']['no_link_url']           = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-url']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'template-args-no-link-url']) :
															$default_content_fire['template']['args']['no_link_url'];

		// Contact Us

		$val['template']['args']['contact_us']['email_placeholder']   = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-email-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-email-placeholder'])) :
																		$default_content_fire['template']['args']['contact_us']['email_placeholder'];

		$val['template']['args']['contact_us']['subject_placeholder'] = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-subject-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-subject-placeholder'])) :
																		$default_content_fire['template']['args']['contact_us']['subject_placeholder'];

		$val['template']['args']['contact_us']['message_placeholder'] = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-message-placeholder']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-message-placeholder'])) :
																		$default_content_fire['template']['args']['contact_us']['message_placeholder'];

		$val['template']['args']['contact_us']['button_text']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-button-text']) ?
																		stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-button-text'])) :
																		$default_content_fire['template']['args']['contact_us']['button_text'];

		$val['template']['args']['contact_us']['email']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-email']) ?
																		sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'contact-us-email']) :
																		$default_content_fire['template']['args']['contact_us']['email'];


		// Args

		$val['args']['mobile']                            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'mobile']) &&
															$_POST[NNRobots_Content_Fire::$prefix_dash . 'mobile'] ? 'yes' : 'no';

		$val['args']['start_date']                        = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'start-date']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'start-date']) :
															date("m/d/Y");

		$val['args']['end_date']                          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'end-date']) ?
															sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'end-date']) :
															date("m/d/Y", mktime(0, 0, 0, date("m"), date("d"), date("Y")+20));

		// Turn off caching ever time user changes this setting

		if (isset($_POST['args-dismiss']) && isset($val['args']['dismiss']) && $val['args']['dismiss'] != $_POST['args-dismiss']) {
			delete_transient(NNRobots_Content_Fire::$prefix . 'dismiss' . $_SERVER['REMOTE_ADDR']);
		}

		$val['args']['dismiss']                   = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-dismiss']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-dismiss'] :
													$default_content_fire['args']['dismiss'];

		$val['args']['show_after_success']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'show-after-success']) &&
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'show-after-success'] ? 'yes' : 'no';

		$val['args']['powered_by']                = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'powered-by']) &&
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'powered-by'] ? 'yes' : 'no';

		$val['args']['ab_testing']['active']      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-active']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-active'] : false;

		$val['args']['ab_testing']['content_fire_id'] = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-content-fire-id']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-content-fire-id'] : false;

		$val['args']['ab_testing']['start_date']  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-start-date']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-ab-testing-start-date'] : false;

		$val['args']['placement']['type']       = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-placement-type']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-placement-type'] :
													$default_content_fire['args']['placement']['type'];

		$val['args']['placement']['paragraphs']   = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-placement-paragraphs']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'args-placement-paragraphs'] :
													$default_content_fire['args']['placement']['paragraphs'];


		// Style

		$val['style']['background_type']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-type']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-type']) :
													$default_content_fire['style']['background_type'];

		$val['style']['background_image']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-image']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-image']) :
													$default_content_fire['style']['background_image'];

		$val['style']['background_color']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-color']) :
													$default_content_fire['style']['background_color'];

		$val['style']['background_pattern']       = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-pattern']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-pattern']) :
													$default_content_fire['style']['background_pattern'];

		$val['style']['background_size']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-size']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'background-size'] :
													$default_content_fire['style']['background_size'];

		$val['style']['background_repeat']        = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-repeat']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'background-repeat'] :
													$default_content_fire['style']['background_repeat'];

		$val['style']['background_position']      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'background-position']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'background-position'] :
													$default_content_fire['style']['background_position'];

		$val['style']['color']                    = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'color']) :
													$default_content_fire['style']['color'];

		$val['style']['heading_color']            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'heading-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'heading-color']) :
													$default_content_fire['style']['heading_color'];


		$val['style']['border_color']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'border-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'border-color']) :
													$default_content_fire['style']['border_color'];

		$val['style']['accent_color']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'accent-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'accent-color']) :
													$default_content_fire['style']['accent_color'];

		$val['style']['button_shape']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'button-shape']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'button-shape']) :
													$default_content_fire['style']['button_shape'];

		$val['style']['nl_color']                 = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'nl-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'nl-color']) :
													$default_content_fire['style']['nl_color'];

		$val['style']['nl_bg_color']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'nl-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'nl-bg-color']) :
													$default_content_fire['style']['nl_bg_color'];

		$val['style']['cu_color']                 = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'cu-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'cu-color']) :
													$default_content_fire['style']['cu_color'];

		$val['style']['cu_bg_color']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'cu-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'cu-bg-color']) :
													$default_content_fire['style']['cu_bg_color'];

		$val['style']['yes_color']                = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'yes-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'yes-color']) :
													$default_content_fire['style']['yes_color'];

		$val['style']['yes_bg_color']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'yes-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'yes-bg-color']) :
													$default_content_fire['style']['yes_bg_color'];

		$val['style']['no_color']                 = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'no-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'no-color']) :
													$default_content_fire['style']['no_color'];

		$val['style']['no_bg_color']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'no-bg-color']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'no-bg-color']) :
													$default_content_fire['style']['no_bg_color'];

		$val['style']['font_size']                = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-size']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-size']) :
													$default_content_fire['style']['font_size'];

		$val['style']['font_weight']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-weight']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-weight']) :
													$default_content_fire['style']['font_weight'];

		$val['style']['google_fonts']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'google-fonts']) &&
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'google-fonts'] ? true : false;

		$val['style']['heading_google_fonts']      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'heading-google-fonts']) &&
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'heading-google-fonts'] ? true : false;

		$val['style']['font_family_heading']      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-family-heading']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-family-heading']) :
													$default_content_fire['style']['font_family_heading'];

		$val['style']['font_family']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-family']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'font-family']) :
													$default_content_fire['style']['font_family'];

		$val['style']['custom_css']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'custom-css']) ?
													stripcslashes($_POST[NNRobots_Content_Fire::$prefix_dash . 'custom-css']) :
													$default_content_fire['style']['custom_css'];


		// Trigger

		$val['trigger']['display_on']          	  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-display-on']) ?
													$_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-display-on'] :
													$default_content_fire['trigger']['display_on'];

		$val['trigger']['args']['users']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-users']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-users']) :
													$default_content_fire['trigger']['args']['users'];

		// User roles

		foreach ($wp_roles->role_names as $role_name => $role) {
			$val['trigger']['args']['user_roles'][$role_name] = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'args-role-' . $role_name]) && $_POST[NNRobots_Content_Fire::$prefix_dash . 'args-role-' . $role_name] ? true : false;
		}

		$val['trigger']['args']['referrer_type']  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-referrer-type']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-referrer-type']) :
													$default_content_fire['trigger']['args']['referrer_type'];

		$val['trigger']['args']['referrer']       = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-referrer']) ?
													sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-args-referrer']) :
													$default_content_fire['trigger']['args']['referrer'];

		$val['trigger']['category']['id']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-category-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-category-id']), ',')) :
													$default_content_fire['trigger']['args']['id'];

		$val['trigger']['tag']['id']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-tag-id']) ?
													str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-tag-id']), ',')) :
													$default_content_fire['trigger']['tag']['id'];

		// Post Types

		foreach ($post_types as $post_type) {
			$val['trigger'][$post_type]['all']		= isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-all-' . $post_type]) &&
													  $_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-all-' . $post_type] ? true : false;

			$val['trigger'][$post_type]['id'] 		= isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-id-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-id-' . $post_type]), ',')) : '';

			$val['trigger'][$post_type]['exclude'] 	= isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-exclude-' . $post_type]) ?
												      str_replace(' ', '', rtrim(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'trigger-exclude-' . $post_type]), ',')) : '';
		}

		// List Items

		$val['template']['args']['list']['color'] 	= isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'list-color']) ?
													  sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'list-color']) :
													  $default_content_fire['template']['args']['list']['color'];

		$list_text = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'list-text']) ? $_POST[NNRobots_Content_Fire::$prefix_dash . 'list-text'] : '';
		$list_icon = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'list-icon']) ? $_POST[NNRobots_Content_Fire::$prefix_dash . 'list-icon'] : '';

		$list_items = array();

		for ($i = 0; $i < count($list_text); $i++) {

			if (isset($list_text[$i]) && $list_text[$i] != '' && $list_icon[$i] != '') {
				$list_items[] = array(
					'icon' 	=> sanitize_text_field($list_icon[$i]),
					'text' 	=> stripslashes(sanitize_text_field($list_text[$i]))
				);
			}
		}

		$val['template']['args']['list']['items'] = $list_items;

		// News Letter

		$val['news_letter']['type']                               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-type']) ?
																	$_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-type'] :
																	$default_content_fire['news_letter']['type'];

		$val['news_letter']['first_name_placeholder']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-first-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-first-name-placeholder'])) :
																	$default_content_fire['news_letter']['first_name_placeholder'];

		$val['news_letter']['last_name_placeholder']              = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-last-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-last-name-placeholder'])) :
																	$default_content_fire['news_letter']['last_name_placeholder'];

		$val['news_letter']['email_placeholder']                  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-email-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-email-placeholder'])) :
																	$default_content_fire['news_letter']['email_placeholder'];

		$val['news_letter']['first_name']                         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-first-name']) &&
																	$_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-first-name'] ? true : false;

		$val['news_letter']['last_name']                          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-last-name']) &&
																	$_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-last-name'] ? true : false;

		$val['news_letter']['success_action']            		  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-action']) ?
																	$_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-action'] :
																	$default_content_fire['news_letter']['success_action'];

		$val['news_letter']['success_url']            		      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-url']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-url']) :
																	$default_content_fire['news_letter']['success_url'];

		$val['news_letter']['success_message']            		  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-message']) ?
																	stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-success-message'])) :
																	$default_content_fire['news_letter']['success_message'];

		$val['news_letter']['button_text']            		      = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-button-text']) ?
																	stripslashes(sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-button-text'])) :
																	$default_content_fire['news_letter']['button_text'];

		// MailChimp

		$val['news_letter']['MailChimp']['api_key']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-api-key']) :
																	$default_content_fire['news_letter']['MailChimp']['api_key'];

		$val['news_letter']['MailChimp']['list']                  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-list']) :
																	$default_content_fire['news_letter']['MailChimp']['list'];

		$val['news_letter']['MailChimp']['optin']                 = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-optin']) &&
																	$_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-MailChimp-optin'] ? true : false;

		// aweber

		$val['news_letter']['aweber']['consumer_key']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) :
																	$default_content_fire['news_letter']['aweber']['consumer_key'];

		$val['news_letter']['aweber']['consumer_secret']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) :
																	$default_content_fire['news_letter']['aweber']['consumer_secret'];

		$val['news_letter']['aweber']['access_key']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-access-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-access-key']) :
																	$default_content_fire['news_letter']['aweber']['access_key'];

		$val['news_letter']['aweber']['access_secret']            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) :
																	$default_content_fire['news_letter']['aweber']['access_secret'];

		$val['news_letter']['aweber']['account_id']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-account-id']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-account-id']) :
																	$default_content_fire['news_letter']['aweber']['account_id'];

		$val['news_letter']['aweber']['list_id']                  = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-list-id']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-aweber-list-id']) :
																	$default_content_fire['news_letter']['aweber']['list_id'];

		// Get Response

		$val['news_letter']['getresponse']['api_key']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) :
																	$default_content_fire['news_letter']['getresponse']['api_key'];

		$val['news_letter']['getresponse']['campaign']            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) :
																	$default_content_fire['news_letter']['getresponse']['campaign'];

		// Campiagn Monitor

		$val['news_letter']['campaignmonitor']['api_key']         = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) :
																	$default_content_fire['news_letter']['campaignmonitor']['api_key'];

		$val['news_letter']['campaignmonitor']['client']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) :
																	$default_content_fire['news_letter']['campaignmonitor']['client'];

		$val['news_letter']['campaignmonitor']['list']            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) :
																	$default_content_fire['news_letter']['campaignmonitor']['list'];

		// Mad Mimi

		$val['news_letter']['madmimi']['api_key']                 = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) :
																	$default_content_fire['news_letter']['madmimi']['api_key'];

		$val['news_letter']['madmimi']['username']                = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-username']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-username']) :
																	$default_content_fire['news_letter']['madmimi']['username'];

		$val['news_letter']['madmimi']['list']                    = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-madmimi-list']) :
																	$default_content_fire['news_letter']['madmimi']['list'];

		// Infusion Soft

		$val['news_letter']['infusionsoft']['app_id']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) :
																	$default_content_fire['news_letter']['infusionsoft']['app_id'];

		$val['news_letter']['infusionsoft']['api_key']            = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) :
																	$default_content_fire['news_letter']['infusionsoft']['api_key'];

		$val['news_letter']['infusionsoft']['list']               = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) :
																	$default_content_fire['news_letter']['infusionsoft']['list'];

		// MyMail

		$val['news_letter']['mymail']['list']                     = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-mymail-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-mymail-list']) :
																	$default_content_fire['mymail']['list'];

		// Active Campaign

		$val['news_letter']['activecampaign']['app_url']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) :
																	$default_content_fire['news_letter']['activecampaign']['app_url'];

		$val['news_letter']['activecampaign']['api_key']          = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) :
																	$default_content_fire['news_letter']['activecampaign']['api_key'];

		$val['news_letter']['activecampaign']['list']             = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-list']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-activecampaign-list']) :
																	$default_content_fire['news_letter']['activecampaign']['list'];

		// feedburner

		$val['news_letter']['feedburner']['id']                   = isset($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-feedburner-id']) ?
																	sanitize_text_field($_POST[NNRobots_Content_Fire::$prefix_dash . 'news-letter-feedburner-id']) :
																	$default_content_fire['aweber']['feedburner']['id'];

		return $val;
	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/core/model/stats.php");
		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/admin/model/db.php");

		// Get Start and End Dates

		$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All content_fire stats

		if (isset($_POST['content_fire_id']) && $_POST['content_fire_id'] == 'false') {

			$stats = NNRobots_Stats_CF::getStats($start_date, $end_date);
			$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");

			$content_fire_stats = array();

			foreach ($content_fires as $content_fire) {
				foreach ($stats as $stat) {

					if ($content_fire->id == $stat['content_fire_id']) {
						$content_fire_stats[$content_fire->id] = array(
							'content_fire_id'		=> $stat['content_fire_id'],
							'content_fire_name'	=> $content_fire->name,
							'content_fire_type'	=> $content_fire->template,
							'date'				=> $stat['date'],
							'impressions'		=> isset($content_fire_stats[$content_fire->id]['impressions']) ? $content_fire_stats[$content_fire->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
							'clicks'			=> isset($content_fire_stats[$content_fire->id]['clicks']) ? $content_fire_stats[$content_fire->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
						);
					}
				}
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($content_fire_stats as $content_fire_stat) {
			    $impressions_total += $content_fire_stat['impressions'];
			    $conversions_total += $content_fire_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph-container">
				<canvas id="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('CTA', NNRobots_Content_Fire::$text_domain) . '</th>
						<th class="' . NNRobots_Content_Fire::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th class="' . NNRobots_Content_Fire::$prefix_dash . 'conversions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . NNRobots_Content_Fire::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</th>
					</thead>';

					foreach ($content_fire_stats as $content_fire_stat) {

						$stats_content .= '<tr>
							<td>
								<a href="' . admin_url() . 'admin.php?page=' . NNRobots_Content_Fire::$stats_page . '&content_fire_id=' . $content_fire_stat['content_fire_id'] . '&content_fire_name=' . $content_fire_stat['content_fire_name'] . '" role="button" class="btn btn-xs btn-primary">
									' .  $content_fire_stat['content_fire_name'] . '
								</a>
							</td>
							<td>' . number_format($content_fire_stat['impressions']) . '</td>';
							$stats_content .= '
							<td>' . number_format($content_fire_stat['clicks']) . '</td>
							<td>' . ($content_fire_stat['impressions'] > 0 ? round(($content_fire_stat['clicks'] / $content_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// Single content_fire stats

		else if (isset($_POST['content_fire_id']) && $_POST['content_fire_id'] != 'false' && isset($_POST['ab_action']) && $_POST['ab_action'] == 'false') {

			$content_fire_stats = NNRobots_Stats_CF::getStats($start_date, $end_date, $_POST['content_fire_id']);

			$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");

			foreach ($content_fires as $content_fire) {
				foreach ($content_fire_stats as $key => $content_fire_stat) {
					if ($content_fire->id == $content_fire_stat['content_fire_id']) {
						$content_fire_stats[$key] = array('content_fire_name' => $content_fire->name) + $content_fire_stats[$key] + array('content_fire_type' => $content_fire->template);
					}
				}
			}

			// Unset indexs

			foreach ($content_fire_stats as $key => $content_fire_stat) {
				unset($content_fire_stats[$key]['id']);
				unset($content_fire_stats[$key]['content_fire_id']);
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($content_fire_stats as $content_fire_stat) {
			    $impressions_total += $content_fire_stat['impressions'];
			    $conversions_total += $content_fire_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph-container">
				<canvas id="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped">

					<thead>
						<th>' . __('Date', NNRobots_Content_Fire::$text_domain) . '</th>
						<th class="' . NNRobots_Content_Fire::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th class="' . NNRobots_Content_Fire::$prefix_dash . 'conversions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . NNRobots_Content_Fire::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</th>
					</thead>';

					foreach (array_reverse($content_fire_stats) as $content_fire_stat) {

						$stats_content .= '<tr>
							<td>' . date('M j Y', strtotime($content_fire_stat['date'])) . '</td>
							<td>' . number_format($content_fire_stat['impressions']) . '</td>';
							$stats_content .= '
							<td>' . number_format($content_fire_stat['clicks']) . '</td>
							<td>' . ($content_fire_stat['impressions'] > 0 ? round(($content_fire_stat['clicks'] / $content_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';

						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// A/B Test stats

		else if ($_POST['ab_action'] == 'ab-testing') {

			$nnrobots_content_fire_db = new NNRobots_Content_Fire_DB();

			$content_fire = $nnrobots_content_fire_db->get_data_from_id($_POST['content_fire_id']);

			$content_fire['news_letter']    = unserialize($content_fire['news_letter']);
			$content_fire['template']       = unserialize($content_fire['template']);
			$content_fire['trigger']        = unserialize($content_fire['trigger']);
			$content_fire['style']          = unserialize($content_fire['style']);
			$content_fire['args']           = unserialize($content_fire['args']);

			// Get Start and End Dates

			$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
			$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

			$post_start_date = urldecode($_POST['start_date']);
			$post_end_date = urldecode($_POST['end_date']);

			if (isset($post_start_date) && $post_start_date != '') {
				$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_start_date));
			}

			if (isset($post_end_date) && $post_end_date != '') {
				$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_end_date));
			}

			// Check for A/B Test Start Date

			if ( strtotime($post_start_date) < strtotime($content_fire['args']['ab_testing']['start_date']) ) {
				$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($content_fire['args']['ab_testing']['start_date']));
			}

			$content_fire_stats = NNRobots_Stats_CF::getStats($start_date, $end_date, $_POST['content_fire_id']);
			$ab_content_fire_stats = NNRobots_Stats_CF::getStats($start_date, $end_date, $content_fire['args']['ab_testing']['content_fire_id']);
			$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");

			// Get stats array for content_fire

			foreach ($content_fires as $content_fire) {
				foreach ($content_fire_stats as $key => $content_fire_stat) {
					if ($content_fire->id == $content_fire_stat['content_fire_id']) {
						$content_fire_stats[$key] = array('content_fire_name' => $content_fire->name) + $content_fire_stats[$key] + array('content_fire_type' => $content_fire->template);
					}
				}
			}

			// Unset indexes

			foreach ($content_fire_stats as $key => $content_fire_stat) {
				unset($content_fire_stats[$key]['id']);
				unset($content_fire_stats[$key]['content_fire_id']);
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($content_fire_stats as $content_fire_stat) {
			    $impressions_total += $content_fire_stat['impressions'];
			    $conversions_total += $content_fire_stat['clicks'];
			}

			// Get stats array for ab content_fire

			foreach ($content_fires as $content_fire) {
				foreach ($ab_content_fire_stats as $key => $ab_content_fire_stat) {
					if ($content_fire->id == $ab_content_fire_stat['content_fire_id']) {
						$ab_content_fire_stats[$key] = array('content_fire_name' => $content_fire->name) + $ab_content_fire_stats[$key] + array('content_fire_type' => $content_fire->template);
					}
				}
			}

			// Unset indexes

			foreach ($ab_content_fire_stats as $key => $ab_content_fire_stat) {
				unset($ab_content_fire_stats[$key]['id']);
				unset($ab_content_fire_stats[$key]['content_fire_id']);
			}

			$ab_impressions_total = 0;
			$ab_clicks_total = 0;
			foreach ($ab_content_fire_stats as $ab_content_fire_stat) {
			    $ab_impressions_total += $ab_content_fire_stat['impressions'];
			    $ab_clicks_total += $ab_content_fire_stat['clicks'];
			}

			$ab_testing_stats = array(
				'content_fire_stats'		=> $content_fire_stats,
				'ab_content_fire_stats'	=> $ab_content_fire_stats,
			);

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;
			$ab_ctr = $ab_impressions_total != 0 ? round(($ab_clicks_total/$ab_impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">A</div>' .
									number_format($impressions_total) .
								'</div>
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">B</div>' .
									number_format($ab_impressions_total) .
								'</div>
						</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">A</div>' .
									number_format($conversions_total) .
								'</div>
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">B</div>' .
									number_format($ab_clicks_total) .
								'</div>
						</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</span>
						<div class="' . NNRobots_Content_Fire::$prefix_dash . 'stats-totals-text">
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">A</div>' .
									$ctr . '%' .
								'</div>
							<div>
								<div class="'  . NNRobots_Content_Fire::$prefix_dash . 'stats-ab-indicator">B</div>' .
									$ab_ctr . '%' .
								'</div>
						</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="col-xs-6">
				<canvas id="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph" style="width: 100%;"></canvas>
			</div>

			<div class="col-xs-6">
				<canvas id="' . NNRobots_Content_Fire::$prefix_dash . 'line-graph-ab" style="width: 100%;"></canvas>
			</div>';

			echo json_encode(array('stats_content' => $stats_content, 'stats' => $ab_testing_stats));

			die(); // this is required to terminate immediately and return a proper response

		}

		echo json_encode(array('stats_content' => $stats_content, 'content_fire_stats' => $content_fire_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails_load() {

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/core/model/email-signups.php");
		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/admin/model/db.php");

		// Get Start and End Dates

		$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_end_date));
		}

		// Get Emails

		global $wpdb;

		$emails = NNRobots_Email_Signups_CF::getEmails($start_date, $end_date);
		$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");

		foreach ($emails as $key => $email) {
			$emails[$key]['content_fire_name'] = '<strong style="color:red;">DELETED</strong>';
		}

		foreach ($content_fires as $content_fire) {
			foreach ($emails as $key => $email) {
				if ($content_fire->id == $email['content_fire_id']) {
					$emails[$key] = array(
						'content_fire_id'		=> $email['content_fire_id'],
						'content_fire_name'	=> $content_fire->name,
						'date'			=> $email['date'],
						'email'			=> $email['email'],
						'first_name'	=> $email['first_name'],
						'last_name'		=> $email['last_name'],
					);
				}
			}
		}

		$emails_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<table class="table table-condensed table-striped">

				<thead>
					<th>' . __('Date', NNRobots_Content_Fire::$text_domain) . '</th>
					<th>' . __('CTA', NNRobots_Content_Fire::$text_domain) . '</th>
					<th>' . __('Email', NNRobots_Content_Fire::$text_domain) . '</th>
					<th>' . __('First Name', NNRobots_Content_Fire::$text_domain) . '</th>
					<th>' . __('Last Name', NNRobots_Content_Fire::$text_domain) . '</th>
				</thead>';

				if (count($emails) < 1) {
					$emails_content .= '<tr>
						<td>' . __('No emails yet', NNRobots_Content_Fire::$text_domain) . '</td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
					</tr>';
				} else {
					foreach (array_reverse($emails) as $content_fire_email) {

						$emails_content .= '<tr>
							<td>' . $content_fire_email['date'] . '</td>
							<td>' . $content_fire_email['content_fire_name'] . '</td>
							<td>' . $content_fire_email['email'] . '</td>
							<td>' . $content_fire_email['first_name'] . '</td>
							<td>' . $content_fire_email['last_name'] . '</td>
						</tr>';

					}
				}

			$emails_content .= '</table>
		</div>';

		echo $emails_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entries_load() {

		// Includes

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/model/email-entries.php');
		require_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$db = new NNRobots_Content_Fire_DB();
		$content_fires = $db->get_content_fires();

		$entries_content = '';

		// Get Start and End Dates

		$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m"), date("d"), date("Y")));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {

			$temp_end_date = strtotime($post_end_date);

			$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m", $temp_end_date), date("d", $temp_end_date), date("Y", $temp_end_date)));
		}

		// Get Entries

		global $wpdb;

		$entries = NNRobots_Email_Entries_CF::getEntries($start_date, $end_date);

		foreach ($entries as $key => $email) {
			$entries[$key]['content_fire_name'] = '<strong style="color:red;">' . __('DELETED', NNRobots_Content_Fire::$text_domain) . '</strong>';
		}

		foreach ($content_fires as $content_fire) {
			foreach ($entries as $key => $entry) {
				if ($content_fire['id'] == $entry['content_fire_id']) {
					$entries[$key]['content_fire_name'] = $content_fire['name'];
				}
			}
		}

		$now = new DateTime();

		if (count($entries) < 1) {
			$entries_content .= '<tr>
				<td>' . __('No entries found', NNRobots_Content_Fire::$text_domain) . '</td>
			</tr>';
		} else {

		$entries_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<div class="col-xs-4 ' . NNRobots_Content_Fire::$prefix_dash . 'entry-list">
				<table class="table table-condensed table-hover">';


						foreach (array_reverse($entries) as $entry) {

							if ( !isset($entry_id) ) {
								$entry_id = $entry['id'];
							}

							$dateTime = new DateTime($entry['date']);

							$message = $entry['message'];

							if ( strlen($message) > 100 ) {
								$message = substr($message, 0, 50) . ' ...';
							}

							$entries_content .= '<tr class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-row" data-entry-id="' . $entry['id'] . '">
								<td>
									<div class="col-xs-12">
										<span class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-email pull-left">' . $entry['email'] . '</span>
										<span class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span>
									</div>
									<div class="col-xs-12">
										<span class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-subject pull-left">' . $entry['subject'] . '</span>
										<span class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-optin pull-right">' . $entry['content_fire_name'] . '</span>
									</div>
									<div class="col-xs-12">
										<p class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-message"><em>' . $message . '</em></p>
									</div>
								</td>
							</tr>';

						}


			$entries_content .= '
				</table>
			</div>
			<div class="col-xs-8 ' . NNRobots_Content_Fire::$prefix_dash . 'single-entry" data-entry-id="' . $entry_id . '"></div>
		</div>';

		}

		echo $entries_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the data for a single entry
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entry_load() {

		// Check if their is an entry id

		if ( !isset($_POST['entry_id']) ) {
			echo '';
			die();
		}

		// Get Entry Data

		global $wpdb;

		$entry = NNRobots_Email_Entries_CF::getEntry($_POST['entry_id']);
		$entry = $entry[0];

		require_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$now = new DateTime();
		$dateTime = new DateTime($entry['date']);

		$entry_content = '<div class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-container">

			<div class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-header-data">
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-info-email">' . $entry['email'] . '<span class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span></div>
				<div class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-info-subject">' . $entry['subject'] . '</div>
			</div>

			<p class="' . NNRobots_Content_Fire::$prefix_dash . 'entry-info-message">' . $entry['message'] . '</p>

		</div>';

		echo $entry_content;

		die();

	}

	/**
	 * Everyday check if there is a record for impressions or clicks for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_content_fire_stats_daily() {

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/core/model/stats.php");

		NNRobots_Stats_CF::initialize_content_fire_stats();
	}

	/**
	 * Email the weekly CTA Stats to the admin account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function setup_content_fire_email_stats() {

		$global_settings = get_option(NNRobots_Content_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if (!$global_settings['send_weekly_email']) {
			return false;
		}

		// Comment this out for testing

		if (date('N') != 7) {
			return false;
		}

		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/core/model/stats.php");
		include_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . "/admin/model/db.php");

		global $wpdb;

		$admins = get_users('role=administrator');

		$start_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
		$end_date = date(NNROBOTS_CONTENT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$stats = NNRobots_Stats_CF::getStats($start_date, $end_date);
		$content_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Content_Fire_DB::getTableName() . "`");
		$content_fire_stats = array();

		foreach ($content_fires as $content_fire) {
			foreach ($stats as $stat) {
				if ($content_fire->id == $stat['content_fire_id']) {
					$content_fire_stats[$content_fire->id] = array(
						'content_fire_id'		=> $stat['content_fire_id'],
						'content_fire_name'	=> $content_fire->name,
						'content_fire_type'	=> $content_fire->template,
						'date'			=> $stat['date'],
						'impressions'	=> isset($content_fire_stats[$content_fire->id]['impressions']) ? $content_fire_stats[$content_fire->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
						'clicks'		=> isset($content_fire_stats[$content_fire->id]['clicks']) ? $content_fire_stats[$content_fire->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
					);
				}
			}
		}

		$impressions_total = 0;
		$conversions_total = 0;
		foreach ($content_fire_stats as $content_fire_stat) {
		    $impressions_total += $content_fire_stat['impressions'];
		    $conversions_total += $content_fire_stat['clicks'];
		}

		$subject = __('Weekly Content Fire Stats!', NNRobots_Content_Fire::$text_domain);

		$head = '<html>
			<head></head>';

		$body = '<body>

				<img src="' . NNROBOTS_CONTENT_FIRE_PLUGIN_URL . '/img/rainbow-strip-hz-wide.png" style="width: 100%;"/>

				<h1>' . __('Content Fire Weekly Stats', NNRobots_Content_Fire::$text_domain) . '</h1>
				<h1>' . date('M j', strtotime($start_date)) . ' - ' . date('M j', strtotime($end_date)) . '</h1>

				<div style="min-height: 20px;
					  padding: 19px;
					  margin-bottom: 20px;
					  background-color: #f5f5f5;
					  border: 1px solid #e3e3e3;
					  border-radius: 4px;
					  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);
					          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);">

					<table style="width:100%; border: none;">

						<col width="33.33%">
						<col width="33.33%">
						<col width="33.33%">

						<thead style="border: none;">
							<th style="border: none;">' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</th>
							<th style="border: none;">' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</th>
							<th style="border: none;">' .  __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</th>
						</thead>

						<tr style="border: none;">
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($impressions_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($conversions_total) . '</td>
							<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . round(($conversions_total/$impressions_total) * 100,2) . '%</td>
						</tr>
					</table>

				</div>
				<table style="width: 100%;
					max-width: 100%;
					margin-bottom: 20px;">

					<thead style="border: 1px solid #ddd;">
						<th style="vertical-align: bottom;
							border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('CTA', NNRobots_Content_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
							line-height: 1.42857143;
							vertical-align: top;">' . __('Impressions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversions', NNRobots_Content_Fire::$text_domain) . '</th>
						<th style="vertical-align: bottom; border-bottom: 2px solid #ddd;padding: 8px;
						  	line-height: 1.42857143;
						  	vertical-align: top;">' . __('Conversion Rate', NNRobots_Content_Fire::$text_domain) . '</th>
					</thead>';

					foreach ($content_fire_stats as $content_fire_stat) {

						$body .= '<tr style="border: 1px solid #ddd;text-align:center;">
							<td>
								<a style="
								  color: white;
								  text-decoration: none;
								  color: #fff;
								  cursor: pointer;
								display: inline-block;
								font-family: \'Helvetica Neue\', Helvetica, Arial, sans-serif;
								font-size: 12px;
								font-stretch: normal;
								font-style: normal;
								font-variant: normal;
								font-weight: normal;
								height: 18px;
								letter-spacing: normal;
								line-height: 18px;
								margin-bottom: 0px;
								margin-left: 0px;
								margin-right: 0px;
								margin-top: 0px;
								overflow-x: visible;
								overflow-y: visible;
								padding-bottom: 1px;
								padding-left: 5px;
								padding-right: 5px;
								padding-top: 1px;
								  background-color: #337ab7;
								  border-color: #2e6da4;
								  -webkit-border-radius: 3px;
								  -moz-border-radius: 3px;
								  border-radius: 3px;" href="' . admin_url() . 'admin.php?page=' . NNRobots_Content_Fire::$stats_page . '&content_fire_id=' . $content_fire_stat['content_fire_id'] . '&content_fire_name=' . $content_fire_stat['content_fire_name'] . '">
									' .  $content_fire_stat['content_fire_name'] . '
								</a>
							</td>
							<td>' . number_format($content_fire_stat['impressions']) . '</td>';

							if ($content_fire_stat['content_fire_type'] == 'Text') {
								$body .= '
								<td>' . __('N/A', NNRobots_Content_Fire::$text_domain) . '</td>
								<td>' . __('N/A', NNRobots_Content_Fire::$text_domain) . '</td>';
							} else {
								$body .= '
								<td>' . number_format($content_fire_stat['clicks']) . '</td>
								<td>' . ($content_fire_stat['impressions'] > 0 ? round(($content_fire_stat['clicks'] / $content_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';
							}

						$body .= '</tr>';
					}

			$body .= '</table>
			</body>';

		$foot = '
			<br/>
			<br/>
			<br/>
			<p style="text-align: center;"><a href="http://wpsite.net">' . __('Visit', NNRobots_Content_Fire::$text_domain) . '</a> ' . __('our site to read about all the latest WordPress News.', NNRobots_Content_Fire::$text_domain) . '</p>
		</html>';

		$message = $head . $body . $foot;
		$headers = array('Content-Type: text/html; charset=UTF-8');

		foreach ( $admins as $admin ) {
			$result = wp_mail($admin->user_email, $subject, $message, $headers);
		}
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		$post_data = array();
		$post_types = get_post_types();

		if ( isset($_POST['post_type']) && in_array($_POST['post_type'], $post_types) ) {

			global $wpdb;

			$post_data = $wpdb->get_results( "SELECT ID, post_title, post_type
		    	FROM " . $wpdb->prefix . "posts
				WHERE post_type = '" . $_POST['post_type'] . "'
				AND post_status IN('publish', 'inherit')" );
		}

		echo json_encode($post_data);

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_categories() {

		echo json_encode(get_categories());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Tags
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_tags() {

		echo json_encode(get_tags());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all MailChimp Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mailchimp_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {
			require_once(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/mailchimp/MailChimp.php');

			$MailChimp = new WPS_MailChimp($_POST['api_key']);
			$lists = $MailChimp->call('lists/list');

			if (isset($lists) && is_array($lists)) {

				foreach ($lists['data'] as $list) {
					$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
				}

				if (isset($_POST['list']) && $_POST['list'] != '') {
					$options = '';

					foreach ($lists['data'] as $list) {
						if ($_POST['list'] == $list['id']) {
							$options .= '<option value="' . $list['id'] . '" selected="selected">' .  $list['name'] . '</option>';
						} else {
							$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the Aweber lists for an account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_aweber_lists() {

		$options = '';
		$consumerKey = '';
		$consumerSecret = '';
		$accessKey = '';
		$accessSecret = '';

		if (isset($_POST['code']) && $_POST['code'] != '') {

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {
				$credentials = AWeberAPI::getDataFromAweberID($_POST['code']);
				list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $credentials;


				$consumerKey    = isset($consumerKey) && !empty($consumerKey) ? $consumerKey : '';
				$consumerSecret = isset($consumerSecret) && !empty($consumerSecret) ? $consumerSecret : '';
				$accessKey      = isset($accessKey) && !empty($accessKey) ? $accessKey : '';
				$accessSecret   = isset($accessSecret) && !empty($accessSecret) ? $accessSecret : '';

			} catch (AWeberAPIException $exc) {
				error_log($exc);
			}

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				foreach ($lists as $list) {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		if (isset($_POST['list']) && $_POST['list'] != '') {

			$consumerKey     = $_POST['consumer_key'];
			$consumerSecret  = $_POST['consumer_secret'];
			$accessKey       = $_POST['access_key'];
			$accessSecret    = $_POST['access_secret'];

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				$options = '';
				foreach ($lists as $list) {
					if ($_POST['list'] == $list->id) {
						$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
					} else {
						$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
					}
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		echo json_encode(array(
			'html'               => $options,
			'consumer_key'       => $consumerKey,
			'consumer_secret'    => $consumerSecret,
			'access_key'         => $accessKey,
			'access_secret'      => $accessSecret,
		));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Get Repsonse Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_getresponse_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/getresponse/jsonRPCClient.php');
			$api = new jsonRPCClient('http://api2.getresponse.com');

			try {
				$result = $api->get_campaigns($_POST['api_key']);
				foreach ((array) $result as $k => $v) {
					$campaigns[] = array('id' => $k, 'name' => $v['name']);
				}
			}

			catch (Exception $e) {}

			if (isset($campaigns) && is_array($campaigns)) {

				foreach ($campaigns as $campaign) {
					$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
				}

				if (isset($_POST['campaign']) && $_POST['campaign'] != '') {
					$options = '';
					foreach ($campaigns as $campaign) {

						if ($_POST['campaign'] == $campaign['id']) {
							$options .= '<option value="' . $campaign['id'] . '" selected="selected">' .  $campaign['name'] . '</option>';
						} else {
							$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_campaignmonitor_lists() {

		$lists = '';
		$clients = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');
			$auth = array('api_key' => $_POST['api_key']);
			$wrap = new CS_REST_General($auth);
			$result = $wrap->get_clients();


			if ($result->was_successful()) {

				foreach ($result->response as $client) {
					$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$clients = '';
					foreach ($result->response as $client) {
						if ($_POST['client'] == $client->ClientID) {
							$clients .= '<option value="' . $client->ClientID . '" selected="selected">' .  $client->Name . '</option>';
						} else {
							$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
						}
					}
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$client_id = $_POST['client'];
				} else {
					$client_id = $result->response[0]->ClientID;
				}

				$wrap = new CS_REST_Clients($client_id, $_POST['api_key']);
				$result = $wrap->get_lists();

				if ($result->was_successful()) {
					foreach ($result->response as $list) {
						$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
					}

					if (isset($_POST['list']) && $_POST['list'] != '') {
						$lists = '';
						foreach ($result->response as $list) {
							if ($_POST['list'] == $list->ListID) {
								$lists .= '<option value="' . $list->ListID . '" selected="selected">' .  $list->Name . '</option>';
							} else {
								$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
							}
						}
					}
				}
			}
		}

		echo json_encode(array('clients' => $clients, 'lists' => $lists));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Update all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function update_campaignmonitor_lists() {

		$lists = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['client_id']) && $_POST['client_id'] != '') {

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');


			$wrap = new CS_REST_Clients($_POST['client_id'], $_POST['api_key']);
			$result = $wrap->get_lists();


			if ($result->was_successful()) {
				foreach ($result->response as $list) {
					$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
				}
			}
		}

		echo $lists;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Mad Mimi Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_madmimi_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['username']) && $_POST['username'] != '') {

			require(NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/madmimi/MadMimi.class.php');

			$mailer = new MadMimi($_POST['username'], $_POST['api_key']);

			if (isset($mailer)) {
				try {
					$lists = $mailer->Lists();
					$lists  = new SimpleXMLElement($lists);

				    if ($lists->list) {
						foreach ($lists->list as $l) {
							$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
						}
				    }

				    if (isset($_POST['list']) && $_POST['list'] != '') {
					    $options = '';
						foreach ($lists->list as $l) {

							if ($_POST['list'] == $l->attributes()->{'name'}->{0}) {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '" selected="selected">' .  $l->attributes()->{'name'}->{0} . '</option>';
							} else {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
							}
						}
					}
				} catch (Exception $exc) {}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all the infusionsoft lists for specfic account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_infusionsoft_lists() {

		if ( ! function_exists( 'curl_init' ) ) {
			return __( 'curl_init is not defined ', NNRobots_Content_Fire::$text_domain);
		}

		if ( ! class_exists( 'iSDK' ) ) {
			require_once( NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/infusionsoft/isdk.php' );
		}

		$options = '';

		// Make sure the use entered in the api key

		if (isset($_POST['app_id']) && $_POST['app_id'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '') {

			try {
				$infusion_app = new iSDK();
				$infusion_app->cfgCon( $_POST['app_id'], $_POST['api_key'], 'throw' );
			} catch( iSDKException $e ){
				$error_message = $e->getMessage();
			}

			if ( empty( $error_message ) ) {
				$need_request = true;
				$page = 0;
				$all_lists = array();

				while ( true == $need_request ) {
					$error_message = 'success';
					$lists_data = $infusion_app->dsQuery( 'ContactGroup', 1000, $page, array( 'Id' => '%' ), array( 'Id', 'GroupName' ) );
					$all_lists = array_merge( $all_lists, $lists_data );

					if ( 1000 > count( $lists_data ) ) {
						$need_request = false;
					} else {
						$page++;
					}
				}
			}

			// Get all list information

			if ( ! empty( $all_lists ) ) {
				foreach( $all_lists as $list ) {

					if ($_POST['list'] == $list['Id']) {
						$options .= '<option value="' . $list['Id'] . '" selected="selected">' .  $list['GroupName'] . '</option>';
					} else {
						$options .= '<option value="' . $list['Id'] . '">' .  $list['GroupName'] . '</option>';
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Get all the MyMail lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mymail_lists() {

		if ( !function_exists('mymail') ) {
			echo '';
			die();
		}

		$lists = mymail('lists')->get();
		$options = '';

		foreach ( $lists as $list ) {
			if ($_POST['list'] == $list->ID) {
				$options .= '<option value="' . $list->ID . '" selected="selected">' .  $list->name . '</option>';
			} else {
				$options .= '<option value="' . $list->ID . '">' .  $list->name . '</option>';
			}
		}

		echo $options;
		die();
	}

	/**
	 * Get all the Active Campaign lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_activecampaign_lists() {

		require_once( NNROBOTS_CONTENT_FIRE_PLUGIN_DIR . 'core/includes/activecampaign/ActiveCampaign.class.php' );

		$options = '';

		if ( isset($_POST['app_url']) && $_POST['app_url'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '' ) {

			$ac = new ActiveCampaign($_POST['app_url'], $_POST['api_key']);

			if ( !(int)$ac->credentials_test() ) {

				echo "";
				exit();
			}

			$lists = $ac->api("list/list?ids=all");

			foreach ( $lists as $list ) {

				if ( !isset($list->id) || empty($list->id) ) {
					continue;
				}

				if ($_POST['list'] == $list->id) {
					$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
				} else {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}
			}
		}

		echo $options;
		die();
	}

	/**
	 * Save the send weekly email setting
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function send_weekly_email() {

		$global_settings = get_option(NNRobots_Content_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if ($_POST['send_weekly_email'] == 'true') {
			$global_settings['send_weekly_email'] = true;
		} else {
			$global_settings['send_weekly_email'] = false;
		}

		update_option(NNRobots_Content_Fire::$prefix . 'global_settings', $global_settings);

		echo '';
		die();
	}

	/**
	 * Checks for element in multidimentional aray
	 *
	 * @access public
	 * @static
	 * @param mixed $needle
	 * @param mixed $haystack
	 * @param bool $strict (default: false)
	 * @return void
	 */
	static function in_array_r($needle, $haystack, $strict = false) {
	    foreach ($haystack as $item) {
	        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && self::in_array_r($needle, $item, $strict))) {
	            return true;
	        }
	    }

	    return false;
	}

	/**
	 * Mulit-byte Unserialize
	 *
	 * UTF-8 will screw up a serialized string
	 *
	 * @access private
	 * @param string
	 * @return string
	 */
	static function mb_unserialize($string) {
	    $string2 = preg_replace_callback(
	        '!s:(\d+):"(.*?)";!s',
	        function($m){
	            $len = strlen($m[2]);
	            $result = "s:$len:\"{$m[2]}\";";
	            return $result;

	        },
	        $string);
	    return unserialize($string2);
	}

}

//endif;