//Created by Kyle Benk kjbenk@gmail.com

jQuery(document).ready(function($) {

	// Load stats via AJAX

	var impression_color           	= "rgb(74, 174, 238)";
	var impression_color_light 		= "rgba(74, 174, 238, 0.2)";
	var conversion_color       		= "rgb(241, 89, 40)";
	var conversion_color_light 		= "rgba(241, 89, 40, 0.2)";

	$.post(ajaxurl, {
			'action': 'nnr_cf_stats_load',
			'ab_action': getQuerystring('action', false),
			'start_date' : getQuerystring(nnr_cf_stats_data.prefix_dash + 'start-date'),
			'end_date' : getQuerystring(nnr_cf_stats_data.prefix_dash + 'end-date'),
			'content_fire_name' : getQuerystring('content_fire_name'),
			'content_fire_id' : getQuerystring('content_fire_id', false),
			'ab_content_fire_name' : getQuerystring('ab_content_fire_name'),
			'ab_content_fire_id' : getQuerystring('ab_content_fire_id', false)}, function(response) {

		response = jQuery.parseJSON(response);

		$("#" + nnr_cf_stats_data.prefix_dash + "loading-stats").remove();
		$(response.stats_content).insertAfter("#" + nnr_cf_stats_data.prefix_dash + "before-table");

		if ($("#" + nnr_cf_stats_data.prefix_dash + "line-graph").length != 0) {

			if (getQuerystring('action', false) == 'ab-testing') {

				var content_fire_stats = response.stats.content_fire_stats;
				var ab_content_fire_stats = response.stats.ab_content_fire_stats;

				var dates = [];
				var content_fires = [];
				var impressions = [];
				var clicks = [];

				$.each(content_fire_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'content_fire_name') {
							content_fires.push(value_1);
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});


				if (getQuerystring('content_fire_name') != '') {
					var labels = dates;
				} else {
					var labels = content_fires;
				}


				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : impression_color_light,
							strokeColor : impression_color,
							pointColor : impression_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : impression_color,
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : conversion_color_light,
							strokeColor : conversion_color,
							pointColor : conversion_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : conversion_color,
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : impression_color_light,
								strokeColor : impression_color,
								pointColor : impression_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : impression_color,
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : conversion_color_light,
								strokeColor : conversion_color,
								pointColor : conversion_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : conversion_color,
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#' + nnr_cf_stats_data.prefix_dash + 'line-graph').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#' + nnr_cf_stats_data.prefix_dash + 'line-graph');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('content_fire_name') != '') {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Content Fire stats page

				else {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}

				var dates = [];
				var content_fires = [];
				var impressions = [];
				var clicks = [];

				$.each(ab_content_fire_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'content_fire_name') {
							content_fires.push(value_1);
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});

				if (getQuerystring('content_fire_name') != '') {
					var labels = dates;
				} else {
					var labels = content_fires;
				}

				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : impression_color_light,
							strokeColor : impression_color,
							pointColor : impression_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : impression_color,
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : conversion_color_light,
							strokeColor : conversion_color,
							pointColor : conversion_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : conversion_color,
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : impression_color_light,
								strokeColor : impression_color,
								pointColor : impression_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : impression_color,
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : conversion_color_light,
								strokeColor : conversion_color,
								pointColor : conversion_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : conversion_color,
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#' + nnr_cf_stats_data.prefix_dash + 'line-graph-ab').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#' + nnr_cf_stats_data.prefix_dash + 'line-graph-ab');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('content_fire_name') != '') {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Firebar stats page

				else {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph-ab").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}

			} else {

				var dates = [];
				var content_fires = [];
				var impressions = [];
				var clicks = [];

				$.each(response.content_fire_stats, function(key, value){
					$.each(value, function(key_1, value_1){

						if (key_1 == 'content_fire_name') {

							//if (value_1.length >= max_name_length) {
								//content_fires.push(value_1.substring(0, max_name_length) + '...');
							//} else {
								content_fires.push(value_1);
							//}
						}

						if (key_1 == 'date') {
							dates.push(value_1);
						}

						if (key_1 == 'impressions') {
							impressions.push(value_1);
						}

						if (key_1 == 'clicks') {
							clicks.push(value_1);
						}
					});
				});


				if (getQuerystring('content_fire_name') != '') {
					var labels = dates;
				} else {
					var labels = content_fires;
				}


				// Line Graph

				var lineChartData = {
					labels : labels,
					datasets : [
						{
							label: "Impressions",
							fillColor : impression_color_light,
							strokeColor : impression_color,
							pointColor : impression_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : impression_color,
							data : impressions
						},
						{
							label: "Clicks",
							fillColor : conversion_color_light,
							strokeColor : conversion_color,
							pointColor : conversion_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : conversion_color,
							data : clicks
						}
					]

				}

				// Show No stats

				if (impressions.length == 0) {

					var lineChartData = {
						labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
						datasets : [
							{
								label: "Impressions",
								fillColor : impression_color_light,
								strokeColor : impression_color,
								pointColor : impression_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : impression_color,
								data : ['25','45','43','18','26','34','21','20','29']
							},
							{
								label: "Clicks",
								fillColor : conversion_color_light,
								strokeColor : conversion_color,
								pointColor : conversion_color,
								pointStrokeColor : "#fff",
								pointHighlightFill : "#fff",
								pointHighlightStroke : conversion_color,
								data : ['12','3','8','6','11','6','3','5','7']
							}
						]

					}

					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
					$('#' + nnr_cf_stats_data.prefix_dash + 'line-graph').css('opacity', '0.5');
					$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#' + nnr_cf_stats_data.prefix_dash + 'line-graph');
				}

				// Show Line graph if there are multiple stats

				else if (impressions.length > 1 && getQuerystring('content_fire_name') != '') {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Line(lineChartData, {
						responsive: true,
					});
				}

				// Show Bar graph if there is only one day of stats  or on all Firebar stats page

				else {
					var ctx = document.getElementById(nnr_cf_stats_data.prefix_dash + "line-graph").getContext("2d");
					window.myLine = new Chart(ctx).Bar(lineChartData, {
						responsive: true,
					});
				}
			}
		}

		$($.bootstrapSortable);

	});

	// Save weekly email settings

	$('input[name="' + nnr_cf_stats_data.prefix_dash + 'send-weekly-email"]').change(function(){

		$.post(ajaxurl, {
			'action': 'nnr_cf_send_weekly_email',
			'send_weekly_email': $('input[name="' + nnr_cf_stats_data.prefix_dash + 'send-weekly-email"]').prop('checked')}, function(response) {

			response = jQuery.parseJSON(response);

		});
	});

	// Date Pickers

	if ($('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').length != 0 &&
		$('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker').length != 0) {

		$('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(nnr_cf_stats_data.today, "M/D/Y") );

		$('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(nnr_cf_stats_data.today, "M/D/Y") );

		$('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.minDate( $('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

		$('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
	       $('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
	    });

	    $('#' + nnr_cf_stats_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
	       $('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
	    });

		if (getQuerystring('action', '') == 'ab-testing') {
			$('#' + nnr_cf_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").minDate(moment(nnr_cf_stats_data.today, "m/d/Y"));
		}

	}

    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}
});